<?php

namespace fk_\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKEkHizmet ArrayType
 * @subpackage Arrays
 */
class ArrayOfKEkHizmet extends AbstractStructArrayBase
{
    /**
     * The KEkHizmet
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \fk_\StructType\KEkHizmet[]
     */
    public $KEkHizmet;
    /**
     * Constructor method for ArrayOfKEkHizmet
     * @uses ArrayOfKEkHizmet::setKEkHizmet()
     * @param \fk_\StructType\KEkHizmet[] $kEkHizmet
     */
    public function __construct(array $kEkHizmet = array())
    {
        $this
            ->setKEkHizmet($kEkHizmet);
    }
    /**
     * Get KEkHizmet value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \fk_\StructType\KEkHizmet[]|null
     */
    public function getKEkHizmet()
    {
        return isset($this->KEkHizmet) ? $this->KEkHizmet : null;
    }
    /**
     * This method is responsible for validating the values passed to the setKEkHizmet method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKEkHizmet method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKEkHizmetForArrayConstraintsFromSetKEkHizmet(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfKEkHizmetKEkHizmetItem) {
            // validation for constraint: itemType
            if (!$arrayOfKEkHizmetKEkHizmetItem instanceof \fk_\StructType\KEkHizmet) {
                $invalidValues[] = is_object($arrayOfKEkHizmetKEkHizmetItem) ? get_class($arrayOfKEkHizmetKEkHizmetItem) : sprintf('%s(%s)', gettype($arrayOfKEkHizmetKEkHizmetItem), var_export($arrayOfKEkHizmetKEkHizmetItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The KEkHizmet property can only contain items of type \fk_\StructType\KEkHizmet, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KEkHizmet value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \fk_\StructType\KEkHizmet[] $kEkHizmet
     * @return \fk_\ArrayType\ArrayOfKEkHizmet
     */
    public function setKEkHizmet(array $kEkHizmet = array())
    {
        // validation for constraint: array
        if ('' !== ($kEkHizmetArrayErrorMessage = self::validateKEkHizmetForArrayConstraintsFromSetKEkHizmet($kEkHizmet))) {
            throw new \InvalidArgumentException($kEkHizmetArrayErrorMessage, __LINE__);
        }
        if (is_null($kEkHizmet) || (is_array($kEkHizmet) && empty($kEkHizmet))) {
            unset($this->KEkHizmet);
        } else {
            $this->KEkHizmet = $kEkHizmet;
        }
        return $this;
    }
    /**
     * Add item to KEkHizmet value
     * @throws \InvalidArgumentException
     * @param \fk_\StructType\KEkHizmet $item
     * @return \fk_\ArrayType\ArrayOfKEkHizmet
     */
    public function addToKEkHizmet(\fk_\StructType\KEkHizmet $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \fk_\StructType\KEkHizmet) {
            throw new \InvalidArgumentException(sprintf('The KEkHizmet property can only contain items of type \fk_\StructType\KEkHizmet, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->KEkHizmet[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \fk_\StructType\KEkHizmet|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \fk_\StructType\KEkHizmet|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \fk_\StructType\KEkHizmet|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \fk_\StructType\KEkHizmet|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \fk_\StructType\KEkHizmet|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KEkHizmet
     */
    public function getAttributeName()
    {
        return 'KEkHizmet';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \fk_\ArrayType\ArrayOfKEkHizmet
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
